From e629c6453a3171b60feeaf2e47e492abc810c981 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 05:56:02 +0000
Subject: [PATCH 1145/2232] Defer writing builtins until after main content


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 1b30446..9696a49 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -18,6 +18,7 @@ pub(super) fn gen<'a>(apis: &[Api], types: &'a Types, opt: &Opt, header: bool) -
         writeln!(out.include, "#pragma once");
     }
 
+    pick_includes_and_builtins(out, apis);
     out.include.extend(&opt.include);
     for api in apis {
         if let Api::Include(include) = api {
@@ -25,11 +26,6 @@ pub(super) fn gen<'a>(apis: &[Api], types: &'a Types, opt: &Opt, header: bool) -
         }
     }
 
-    pick_includes_and_builtins(out, apis);
-    write_builtins(out);
-
-    out.next_section();
-
     let apis_by_namespace = NamespaceEntries::new(apis);
 
     gen_namespace_forward_declarations(out, &apis_by_namespace);
@@ -40,6 +36,7 @@ pub(super) fn gen<'a>(apis: &[Api], types: &'a Types, opt: &Opt, header: bool) -
         write_generic_instantiations(out);
     }
 
+    write_builtins(out);
     write_includes(out);
 
     out_file

